﻿namespace ProjectByldozer;

/// <summary>
/// Класс-сущность "Спортивный автомобиль"
/// </summary>
public class EntityByldozer
{
	/// <summary>
	/// Скорость
	/// </summary>
	public int Speed { get; private set; }

	/// <summary>
	/// Вес
	/// </summary>
	public double Weight { get; private set; }

	/// <summary>
	/// Основной цвет
	/// </summary>
	public Color BodyColor { get; private set; }

	/// <summary>
	/// Дополнительный цвет (для опциональных элементов)
	/// </summary>
	public Color AdditionalColor { get; private set; }

	/// <summary>
	/// Признак (опция) наличия отвала
	/// </summary>
	public bool Dump { get; private set; }

	/// <summary>
	/// Признак (опция) наличия разрыхлителя
	/// </summary>
	public bool Bakingpowder { get; private set; }

	/// <summary>
	/// Признак (опция) наличия трубы
	/// </summary>
	public bool Pipe { get; private set; }

	/// <summary>
	/// Шаг перемещения автомобиля
	/// </summary>
	public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Инициализация полей объекта-класса спортивного автомобиля
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="dump">Признак наличия обвеса</param>
    /// <param name="bakingpowder">Признак наличия антикрыла</param>
    /// <param name="pipe">Признак наличия трубы</param>
    public void Init(int speed, double weight, Color bodyColor, Color additionalColor, bool dump, bool bakingpowder, bool pipe)
	{
		Speed = speed;
		Weight = weight;
		BodyColor = bodyColor;
		AdditionalColor = additionalColor;
        Dump = dump;
        Bakingpowder = bakingpowder;
        Pipe = pipe;
	}
}