﻿using System;
using System.Collections.Generic;
using System.ComponentModel;


namespace ProjectByldozer;
/// <summary>
/// форма рыботы с обьектом "бульдозер"
/// </summary>
public partial class FormByldozer : Form
{
    /// <summary>
    /// поле-объект для прорисовки обьекта
    /// </summary>
    private DrawningByldozer? _drawningByldozer;
    /// <summary>
    /// инциализация формы
    /// </summary>
    public FormByldozer()
    {
        InitializeComponent();
    }
    /// <summary>
    /// метод прорисовки 
    /// </summary>
    private void Draw()
    {
        if (_drawningByldozer == null)
        {
            return;
        }
        Bitmap bmp = new(pictureBoxByldozer.Width, pictureBoxByldozer.Height);
        Graphics gr = Graphics.FromImage(bmp);
        _drawningByldozer.DrawTransport(gr);
        pictureBoxByldozer.Image = bmp;

    }
    /// <summary>
    /// обработка нажатия кнопки "создать"
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonCreateByldozer_Click(object sender, EventArgs e)
    {
        Random random = new();
        _drawningByldozer = new DrawningByldozer();
        _drawningByldozer.Init(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
        _drawningByldozer.SetPictureSize(pictureBoxByldozer.Width, pictureBoxByldozer.Height);
        _drawningByldozer.SetPosition(random.Next(10, 100), random.Next(10, 100));

        Draw();


    }
    /// <summary>
    /// премещение объекта по форме
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonMove_Click(object sender, EventArgs e)
    {
        if (_drawningByldozer == null)
        {
            return;
        }
        string name = ((Button)sender)?.Name ?? string.Empty;
        bool result = false;
        switch (name)
        {
            case "buttonUp":
                result = _drawningByldozer.MoveTransport(ProjectSportCar.DirectionType.Up);
                break;
            case "buttonDown":
                result = _drawningByldozer.MoveTransport(ProjectSportCar.DirectionType.Down);
                break;
            case "buttonLeft":
                result = _drawningByldozer.MoveTransport(ProjectSportCar.DirectionType.Left);
                break;
            case "buttonRight":
                result = _drawningByldozer.MoveTransport(ProjectSportCar.DirectionType.Right);
                break;
        }
        if (result)
        {
            Draw();
        }
    }
}
